# -*- coding: utf-8 -*-
#
# Copyright (C) 2013 Dirk Stöcker <trac@dstoecker.de>
# All rights reserved.
#
# This software is licensed as described in the file COPYING, which
# you should have received as part of this distribution. The terms
# are also available at http://trac.edgewall.com/license.html.
#
# This software consists of voluntary contributions made by many
# individuals. For the exact contribution history, see the revision
# history and logs, available at http://projects.edgewall.com/trac/.
#
# Author: Dirk Stöcker <trac@dstoecker.de>,

import re

from trac.config import IntOption, Option, BoolOption
from trac.core import *
from tracspamfilter.api import IFilterStrategy, N_

class IP6FilterStrategy(Component):
    """Spam filter for submitter's IP based on IP type"""
    implements(IFilterStrategy)

    karma_points = IntOption('spam-filter', 'ip6_karma', '5',
        """By how many points a IPv6 address improves the overall
        karma of a submission.""", doc_domain="tracspamfilter")

    # IFilterStrategy implementation

    def is_external(self):
        return False

    def test(self, req, author, content, ip):
        if ':' in ip:
            return self.karma_points, N_('IPv6 address detected')

    def train(self, req, author, content, ip, spam=True):
        pass
